﻿#Region "FileHeader"
#If False Then
#End If
'-- Options, Imports
#End Region 'FileHeader

Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic

   Public Module CollectionX

      <Extension()> _
      Public Function IndexOf(Of TItem, TKey)(items As IList(Of TItem), selector As Func(Of TItem, TKey), key As TKey, Optional start As Integer = 0) As Integer
         For IndexOf = start To items.Count - 1
            If Object.Equals(selector(items(IndexOf)), key) Then Exit Function
         Next
         Return -1
      End Function
      <Extension()> _
      Public Function FindIndex(Of T)(items As IList(Of T), predicate As Func(Of T, Boolean), Optional start As Integer = 0) As Integer
         For FindIndex = start To items.Count - 1
            If predicate(items(FindIndex)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension()> _
      Public Function FindIndex(Of T)(items As IList, predicate As Func(Of T, Boolean), Optional start As Integer = 0) As Integer
         For FindIndex = start To items.Count - 1
            If predicate(DirectCast(items(FindIndex), T)) Then Exit Function
         Next
         Return -1
      End Function

      <Extension(), DebuggerStepThrough> _
      Public Sub ForEach(Of T)(items As IEnumerable(Of T), Action As Action(Of T))
         For Each itm In items : Action(itm) : Next
      End Sub
      <Extension()> _
      Public Sub ForEach(Of T)(items As IEnumerable(Of T), Action As Action(Of Integer, T), Optional start As Integer = 0)
         For Each itm In items
            Action(start, itm)
            start += 1
         Next
      End Sub

      <Extension()> _
      Public Function Take(Of T)(items As IEnumerable(Of T), start As Integer, count As Integer) As IEnumerable(Of T)
         Return items.Skip(start).Take(count)
      End Function

      <Extension()> _
      Public Function Except(Of T)(items As IEnumerable(Of T), item As T) As IEnumerable(Of T)
         Return items.Except(New T() {item})
      End Function

      <Extension()> _
      Public Function ToArray(Of T, T2)(items As IEnumerable(Of T), selector As Func(Of T, T2)) As T2()
         Return items.Select(selector).ToArray
      End Function
      <Extension()> _
      Public Function ToList(Of T, T2)(items As IEnumerable(Of T), selector As Func(Of T, T2)) As List(Of T2)
         Return items.Select(selector).ToList
      End Function
      <Extension()> _
      Public Function ToListFiltered(Of T)(items As IEnumerable(Of T), filter As Func(Of T, Boolean)) As List(Of T)
         Return items.Where(filter).ToList
      End Function
      <Extension()> _
      Public Function ToList(Of T)(items As IEnumerable(Of T), other As IEnumerable(Of T), ParamArray more() As IEnumerable(Of T)) As List(Of T)
         Dim src(1 + more.Length) As IEnumerable(Of T)
         src(0) = items
         src(1) = other
         Array.Copy(more, 0, src, 2, more.Length)
         Return src.SelectMany(Function(answers) answers).ToList
      End Function

   End Module

End Namespace
