﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics

Namespace System

   Public Module ObjectX
      ''' <summary>trycast value to desired Type and assigns it.</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function TryBe(Of T As Class)(ByRef target As T, value As Object) As Boolean
         Dim x = TryCast(value, T)
         If x Is Nothing Then Return False
         target = x
         Return True
      End Function
      ''' <summary>cast value to desired Type and assigns it. Causes InvalidCastException on failure</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Sub Be(Of T)(ByRef target As T, value As Object)
         target = DirectCast(value, T)
      End Sub
      <DebuggerStepThrough(), Extension()> _
      Public Function CastX(Of T)(Obj As Object) As T
         Return DirectCast(Obj, T)
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function TryCastX(Of T As Class)(Obj As Object) As T
         Return TryCast(Obj, T)
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function CloneX(Of T As ICloneable)(Obj As T) As T
         Return DirectCast(Obj.Clone(), T)
      End Function
      
      <DebuggerStepThrough(), Extension()> _
      Public Function Null(Of T As Class)(Subj As T) As Boolean
         Return Subj Is Nothing
      End Function
      
      <DebuggerStepThrough(), Extension()> _
      Public Function NotNull(Of T As Class)(Subj As T) As Boolean
         Return Subj IsNot Nothing
      End Function

   End Module
End Namespace
