﻿#Region "FileHeader"
#If False Then
Person-DataClass: Main-Attributes (as to persist on Disk): Name, Phone, Birthday, Rate
Moreover two commands: one for UpRate, one for DownRate.
#End If '-- Options, Imports
#End Region 'FileHeader

Imports System.ComponentModel

Public Class Person : Inherits NotifyPropertyChanged

   Public Property cmdUpRate() As New RelayCommand(Sub() Rate += 1, Function() _Rate < 10)
   Public Property cmdDownRate() As New RelayCommand(Sub() Rate -= 1, Function() _Rate > 1)

   Private _Rate As Integer = 5
   Public Property Rate() As Integer
      Get
         Return _Rate
      End Get
      Set(ByVal value As Integer)
         ChangePropIfDifferent(value, _Rate)
      End Set
   End Property
   Private _Name As String
   Public Property Name() As String
      Get
         Return _Name
      End Get
      Set(value As String)
         ChangePropIfDifferent(value, _Name)
      End Set
   End Property
   Private _Phone As String
   Public Property Phone() As String
      Get
         Return _Phone
      End Get
      Set(value As String)
         ChangePropIfDifferent(value, _Phone)
      End Set
   End Property
   Private _BirthDay As DateTime
   Public Property BirthDay() As DateTime
      Get
         Return _BirthDay
      End Get
      Set(value As DateTime)
         ChangePropIfDifferent(value, _BirthDay)
      End Set
   End Property
   Public Sub New()
   End Sub
   Public Sub New(name As String, phone As String, birth As DateTime, rate As Integer)
      _Name = name
      _Phone = phone
      _BirthDay = birth
      _Rate = rate
   End Sub

   Public Shared Function FromInt(i As Integer) As Person
      'to create TestData at DesignTime
      Return New Person("Person" & i, "54321" & i, DateTime.Today.AddYears(-60 + i), 1 + i Mod 9)
   End Function

End Class
