﻿#Region "FileHeader"
#If False Then
A MainModel-Object is to instanciate in Application.Xaml.Resources, to support Bindeability to any Xaml in this Application.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.Globalization
#End Region 'FileHeader

Public Class MainModel : Inherits MainModelBase(Of MainModel)

   Private Const _DataSeparator As Char = Microsoft.VisualBasic.ChrW(&HF018)
   Private _DataFile As New FileInfo("..\..\PersonData.txt")

   Private WithEvents __Persons As New ObservableCollection(Of Person)() ' Public WithEvents to support Designer-Data-Preview
   Public Property Persons() As New ListCollectionView(__Persons) ' enables to access/observe the currently selected Person

   Public Property cmdFill() As New RelayCommand(AddressOf Load)
   Public Property cmdSave() As New RelayCommand(AddressOf Save)
   Public Property cmdDoSomething() As New RelayCommand(AddressOf DoSomethingWithAPerson, Function() Persons.CurrentPosition >= 0)
   Public Property cmdAdd() As New RelayCommand(Sub() Persons.AddNewItem(New Person() With {.Name = "<aName>"}))
   Public Property cmdDelete() As New RelayCommand(Of Person)(AddressOf Persons.Remove, Function() Persons.CurrentPosition >= 0)

   Public Sub New()
      If IsProvisional Then ' TestData for Designer-Data-Preview
         Enumerable.Range(0, 10).ForEach(Sub(i) __Persons.Add(Person.FromInt(i)))
         Persons.MoveCurrentToFirst()
         Return
      End If
      Load()
   End Sub

   Private Sub Save()
      Using writer = _DataFile.CreateText
         For Each pers In __Persons
            With pers
               writer.WriteLine(_DataSeparator.Between(.Name, .Phone, .BirthDay.ToString(CultureInfo.InvariantCulture), .Rate))
            End With
         Next
      End Using
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

   Private Sub Load()
      __Persons.Clear()
      Using reader = _DataFile.OpenText
         While Not reader.EndOfStream
            Dim data = reader.ReadLine.Split(_DataSeparator)
            __Persons.Add(New Person(data(0), data(1), Date.Parse(data(2), CultureInfo.InvariantCulture), Integer.Parse(data(3))))
         End While
      End Using
      Persons.MoveCurrentToFirst()
   End Sub

   Private Sub DoSomethingWithAPerson()
      Dim person = __Persons(Persons.CurrentPosition) '  access the currently selected Person
      Msg("Aktuell angewählte Person: ", person.Name)
   End Sub

   Private Sub __Persons_CollectionChanged(sender As Object, e As Collections.Specialized.NotifyCollectionChangedEventArgs) Handles __Persons.CollectionChanged
      If e.Action <> Collections.Specialized.NotifyCollectionChangedAction.Remove Then Return
      ' ensure always a person is selected (as long as any exists)
      If Not Persons.MoveCurrentToNext() Then Persons.MoveCurrentToPrevious()
   End Sub

End Class
